package org.greenstone.gsdl3.util;

public class GSSQL {

    // table names
    public static String DOCUMENT_TABLE = "document";
    public static String STRUCTURE_TABLE = "structure";
    public static String DIVISION_TABLE = "divisions";
    public static String DIVISION_FILE_TABLE = "divisionfilerefs";
    public static String DIVISION_METADATA_TABLE = "divisionmetarefs";
    public static String FILE_SECTION_TABLE = "filesection";
    public static String FILE_GROUP_TABLE = "filegroups";
    public static String FILE_TABLE = "files";
    public static String METADATA_TABLE = "metadata"; 
    public static String NAMESPACE_TABLE = "namespaces";
    public static String METADATA_VALUE_TABLE = "mdvalues";

    // unique key names - references to the tables
    public static String METADATA_REF = "MetadataRef";
    public static String NAMESPACE_REF = "NamespaceRef";
    public static String STRUCTURE_REF = "StructureRef";
    public static String DIVISION_REF = "DivisionRef";
    public static String FILE_SECTION_REF = "FileSectionRef";
    public static String FILE_GROUP_REF = "FileGroupRef";

    // combined refs
    public static String PARENT_REF = "ParentRef";
    public static String PARENT_TYPE = "ParentType";
    
    // other fields - these are unique ids per document - ie combined with docid
    public static String DOCUMENT_ID = "DocID";
    public static String METADATA_ID = "MetaID";
    public static String FILE_ID = "FileID";
    public static String STRUCTURE_ID = "StructureID";
    public static String SECTION_ID = "SectionID";
    public static String FILE_GROUP_ID = "FileID";
    public static String FILE_SECTION_ID = "FileID";
    
    // type fields
    public static String DOC_TYPE = "DocType";
    public static String NAMESPACE_TYPE = "NamespaceType";
    public static String STRUCTURE_TYPE = "StructureType";
    public static String DIVISION_TYPE = "DivisionType";
    public static String FILE_LOCATION_TYPE = "FileLocType";
    public static String MIME_TYPE = "MIMEType";

    // label fields
    public static String LABEL = "Label";
    public static String VALUE = "Value";
    public static String LABEL_ORDER = "LabelOrder";
    public static String SHORT_LABEL = "ShortLabel";
    public static String USER_LABEL = "UserLabel";
    
    // other stuff
    public static String FILE_LOCATION = "FileLocation";
    public static String CREATOR = "Creator";
    
    public static String MG_NUM = "mgseqno";

    public static String COMMA = ",";
    public static String EQUALS = "=";
    public static String QUOTE = "'";
    public static String EQUALS_QUOTE = "='";
    public static String DOT = ".";
    public static String END = ";";
}
