package org.greenstone.gsdl3.util;

import org.greenstone.gsdl3.gs3build.util.GS3SQLConnectionFactory;
import org.greenstone.gsdl3.gs3build.util.GS3SQLConnection;

import java.sql.ResultSet;
import java.sql.SQLException;
public class SQLQuery {
    GS3SQLConnection connection = null;
    
    public SQLQuery() {

    }

    public boolean setDatabase(String db_name) {
	connection = GS3SQLConnectionFactory.createConnection(db_name);

	// test the connection
	String query = "select * from "+GSSQL.DOCUMENT_TABLE+GSSQL.END;
	if (!connection.execute(query)) {
	    connection = null;
	    return false;
	}
	return true;
    }

    public String MGNum2OID(int mg_num) {
	// get doc id and meta id
	String query = "select "+ 
	    GSSQL.METADATA_TABLE+GSSQL.DOT+GSSQL.METADATA_ID+
	    GSSQL.COMMA+GSSQL.METADATA_TABLE+GSSQL.DOT+GSSQL.DOCUMENT_ID+
	    " from "+GSSQL.METADATA_VALUE_TABLE+GSSQL.COMMA+GSSQL.NAMESPACE_TABLE+GSSQL.COMMA+GSSQL.METADATA_TABLE+
	    " where "+
	    GSSQL.METADATA_VALUE_TABLE+GSSQL.DOT+GSSQL.LABEL+GSSQL.EQUALS_QUOTE+GSSQL.MG_NUM+GSSQL.QUOTE+
	    " and "+GSSQL.METADATA_VALUE_TABLE+GSSQL.DOT+GSSQL.VALUE+GSSQL.EQUALS_QUOTE+mg_num+GSSQL.QUOTE+
	    " and "+GSSQL.METADATA_VALUE_TABLE+GSSQL.DOT+GSSQL.NAMESPACE_REF+GSSQL.EQUALS+GSSQL.NAMESPACE_TABLE+GSSQL.DOT+GSSQL.NAMESPACE_REF+
	    " and "+GSSQL.NAMESPACE_TABLE+GSSQL.DOT+GSSQL.METADATA_REF+GSSQL.EQUALS+GSSQL.METADATA_TABLE+GSSQL.DOT+GSSQL.METADATA_REF+
	    GSSQL.END;
	
	connection.execute(query);
	ResultSet results = null;
	String doc_id = null;
	String meta_id = null;
	try {
	    results = connection.getResultSet();
	    results.first();
	    doc_id = results.getString(GSSQL.DOCUMENT_ID);
	    meta_id = results.getString(GSSQL.METADATA_ID);
	} catch (java.sql.SQLException e) {

	    System.err.println("somethings went wrong with sql "+e.getMessage());
	    return null;
	}
	System.out.println("doc id ="+doc_id+", meta id = "+meta_id);

	// now get division label
	query = "select "+
	    GSSQL.DIVISION_TABLE+GSSQL.DOT+GSSQL.SHORT_LABEL+
	    " from "+GSSQL.DIVISION_TABLE+GSSQL.COMMA+GSSQL.DIVISION_METADATA_TABLE+
	    " where "+GSSQL.DIVISION_METADATA_TABLE+GSSQL.DOT+GSSQL.METADATA_ID+GSSQL.EQUALS_QUOTE+meta_id+GSSQL.QUOTE+
	    " and "+GSSQL.DIVISION_METADATA_TABLE+GSSQL.DOT+GSSQL.DOCUMENT_ID+GSSQL.EQUALS_QUOTE+doc_id+GSSQL.QUOTE+
	    GSSQL.END;

	connection.execute(query);
	String short_label = null;
	try {
	    results = connection.getResultSet();
	    results.first();
	    short_label = results.getString(GSSQL.SHORT_LABEL);

	} catch (java.sql.SQLException e) {

	    System.err.println("somethings went wrong with sql "+e.getMessage());
	    return null;
	}

	System.out.println("short label = "+short_label);

	System.out.println("doc_id = "+doc_id+"."+short_label);
	return doc_id+"."+short_label;
    }

    public int OID2MGNum(String oid) {
	
	String id = getMetadata(oid, "gsdl3.mgseqno");
	System.out.println("mg id = "+id);
	return Integer.parseInt(id);

    }

    public String getMetadata(String oid, String full_meta_name) {

	String doc_id = oid;
	String section_id = "All"; // if we are just passed a doc id
	int sep_index = oid.indexOf(".");
	if (sep_index != -1) {
	    doc_id = oid.substring(0, sep_index);
	    section_id = oid.substring(sep_index+1);
	}

	System.out.println("get meta for "+oid+", doc id = "+doc_id+"sec id = "+section_id);

	// get teh metadata block id
	String query = "select "+ 
	    GSSQL.DIVISION_METADATA_TABLE+GSSQL.DOT+GSSQL.METADATA_ID +
	    " from " + GSSQL.DIVISION_METADATA_TABLE+GSSQL.COMMA+GSSQL.DIVISION_TABLE+
	    " where " + GSSQL.DIVISION_TABLE+GSSQL.DOT+GSSQL.DIVISION_REF+GSSQL.EQUALS+GSSQL.DIVISION_METADATA_TABLE+GSSQL.DOT+GSSQL.DIVISION_REF+
	    " and " + GSSQL.DIVISION_TABLE+GSSQL.DOT+GSSQL.SHORT_LABEL+GSSQL.EQUALS_QUOTE+section_id+GSSQL.QUOTE+
	    " and " + GSSQL.DIVISION_TABLE+GSSQL.DOT+GSSQL.DOCUMENT_ID+GSSQL.EQUALS_QUOTE+doc_id+GSSQL.QUOTE+
	    " and "+GSSQL.DIVISION_METADATA_TABLE+GSSQL.DOT+GSSQL.DOCUMENT_ID+GSSQL.EQUALS_QUOTE+doc_id+GSSQL.QUOTE+ 
	    GSSQL.END;
	
	connection.execute(query);
	ResultSet results = null;
	String meta_id = null;
	try {
	    results = connection.getResultSet();
	    results.first();
	    meta_id = results.getString(GSSQL.METADATA_ID);
	} catch (java.sql.SQLException e) {

	    System.err.println("somethings went wrong with sql "+e.getMessage());
	    return null;
	}
	System.err.println("metadata block id = "+meta_id);

	// now get the list of namespace refs for the right namespace
	sep_index = full_meta_name.indexOf('.');
	String meta_ns = "gsdl3";
	String meta_name = full_meta_name;
	if (sep_index != -1) {

	    meta_ns = full_meta_name.substring(0, sep_index);
	    meta_name = full_meta_name.substring(sep_index+1);
	}
	System.out.println("orig meta = "+full_meta_name+", ns = "+meta_ns+", name="+meta_name);

	query = "select * "+ 
	    " from "+GSSQL.NAMESPACE_TABLE+GSSQL.COMMA+GSSQL.METADATA_TABLE+GSSQL.COMMA+GSSQL.METADATA_VALUE_TABLE+
	    " where "+GSSQL.METADATA_TABLE+GSSQL.DOT+GSSQL.METADATA_ID+GSSQL.EQUALS_QUOTE+meta_id+GSSQL.QUOTE+
	    " and "+ GSSQL.METADATA_TABLE+GSSQL.DOT+GSSQL.DOCUMENT_ID+GSSQL.EQUALS_QUOTE+doc_id+GSSQL.QUOTE+
	    " and " + GSSQL.METADATA_TABLE+GSSQL.DOT+GSSQL.METADATA_REF+GSSQL.EQUALS+GSSQL.NAMESPACE_TABLE+GSSQL.DOT+GSSQL.METADATA_REF+
	    " and "+ GSSQL.NAMESPACE_TABLE+GSSQL.DOT+GSSQL.NAMESPACE_TYPE+GSSQL.EQUALS_QUOTE+meta_ns+GSSQL.QUOTE+
	    " and "+GSSQL.NAMESPACE_TABLE+GSSQL.DOT+GSSQL.NAMESPACE_REF+GSSQL.EQUALS+GSSQL.METADATA_VALUE_TABLE+GSSQL.DOT+GSSQL.NAMESPACE_REF+
	    GSSQL.END;
	System.out.println("query="+query);
	connection.execute(query);
	String meta_value = null;
	try {
	    results = connection.getResultSet();
	    while (results.next()) {
		String m_name = results.getString(GSSQL.LABEL);
		if (meta_name.equals(m_name)) {
		    meta_value = results.getString(GSSQL.VALUE);
		    break;
		}
	    }
	} catch (java.sql.SQLException e) {

	    System.err.println("somethings went wrong with sql "+e.getMessage());
	    return null;
	}
	
	return meta_value;
    }
    public static void main (String [] args) {

	SQLQuery self = new SQLQuery();
	self.setDatabase("gs3test");
	System.out.println("getting oid for mg num 3");
	String oid = self.MGNum2OID(3);
	System.out.println("oid was "+oid);
	
	System.out.println("title metadata for mg num 3:");
	String meta = self.getMetadata(oid, "gsdl3.title");
	if (meta != null) {System.out.println(meta);}
	System.out.println("subject metadata for mg num 3:");
	meta = self.getMetadata(oid, "gsdl3.Subject");
	if (meta != null) {System.out.println(meta);}

	System.out.println("converting back to mg, oid "+oid);
	int id = self.OID2MGNum(oid);
	System.out.println(""+id);

	System.out.println("getting oid for mg num 8");
	oid = self.MGNum2OID(8);
	System.out.println("oid was "+oid);

	System.out.println("title metadata for mg num 8:");
	meta = self.getMetadata(oid, "gsdl3.title");
	if (meta != null) {System.out.println(meta);}
	System.out.println("subject metadata for mg num 8:");
	meta = self.getMetadata(oid, "gsdl3.Subject");
	if (meta != null) {System.out.println(meta);}

	System.out.println("converting back to mg, oid "+oid);
	id = self.OID2MGNum(oid);
	System.out.println(""+id);
    }




}
